<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEndpoint ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEndpoint
 * @subpackage Arrays
 */
class ArrayOfEndpoint extends AbstractStructArrayBase
{
    /**
     * The Endpoint
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Endpoint[]
     */
    public $Endpoint;
    /**
     * Constructor method for ArrayOfEndpoint
     * @uses ArrayOfEndpoint::setEndpoint()
     * @param \StructType\Endpoint[] $endpoint
     */
    public function __construct(array $endpoint = array())
    {
        $this
            ->setEndpoint($endpoint);
    }
    /**
     * Get Endpoint value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Endpoint[]|null
     */
    public function getEndpoint()
    {
        return isset($this->Endpoint) ? $this->Endpoint : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEndpoint method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEndpoint method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEndpointForArrayConstraintsFromSetEndpoint(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEndpointEndpointItem) {
            // validation for constraint: itemType
            if (!$arrayOfEndpointEndpointItem instanceof \StructType\Endpoint) {
                $invalidValues[] = is_object($arrayOfEndpointEndpointItem) ? get_class($arrayOfEndpointEndpointItem) : sprintf('%s(%s)', gettype($arrayOfEndpointEndpointItem), var_export($arrayOfEndpointEndpointItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Endpoint property can only contain items of type \StructType\Endpoint, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Endpoint value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Endpoint[] $endpoint
     * @return \ArrayType\ArrayOfEndpoint
     */
    public function setEndpoint(array $endpoint = array())
    {
        // validation for constraint: array
        if ('' !== ($endpointArrayErrorMessage = self::validateEndpointForArrayConstraintsFromSetEndpoint($endpoint))) {
            throw new \InvalidArgumentException($endpointArrayErrorMessage, __LINE__);
        }
        if (is_null($endpoint) || (is_array($endpoint) && empty($endpoint))) {
            unset($this->Endpoint);
        } else {
            $this->Endpoint = $endpoint;
        }
        return $this;
    }
    /**
     * Add item to Endpoint value
     * @throws \InvalidArgumentException
     * @param \StructType\Endpoint $item
     * @return \ArrayType\ArrayOfEndpoint
     */
    public function addToEndpoint(\StructType\Endpoint $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Endpoint) {
            throw new \InvalidArgumentException(sprintf('The Endpoint property can only contain items of type \StructType\Endpoint, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Endpoint[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Endpoint|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Endpoint|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Endpoint|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Endpoint|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Endpoint|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Endpoint
     */
    public function getAttributeName()
    {
        return 'Endpoint';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfEndpoint
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
