<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCompanyEndpointsByServiceType StructType
 * @subpackage Structs
 */
class GetCompanyEndpointsByServiceType extends AbstractStructBase
{
    /**
     * The companyCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $companyCode;
    /**
     * The serviceTypeCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $serviceTypeCode;
    /**
     * Constructor method for GetCompanyEndpointsByServiceType
     * @uses GetCompanyEndpointsByServiceType::setCompanyCode()
     * @uses GetCompanyEndpointsByServiceType::setServiceTypeCode()
     * @param string $companyCode
     * @param string $serviceTypeCode
     */
    public function __construct($companyCode = null, $serviceTypeCode = null)
    {
        $this
            ->setCompanyCode($companyCode)
            ->setServiceTypeCode($serviceTypeCode);
    }
    /**
     * Get companyCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCompanyCode()
    {
        return isset($this->companyCode) ? $this->companyCode : null;
    }
    /**
     * Set companyCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $companyCode
     * @return \StructType\GetCompanyEndpointsByServiceType
     */
    public function setCompanyCode($companyCode = null)
    {
        // validation for constraint: string
        if (!is_null($companyCode) && !is_string($companyCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($companyCode, true), gettype($companyCode)), __LINE__);
        }
        if (is_null($companyCode) || (is_array($companyCode) && empty($companyCode))) {
            unset($this->companyCode);
        } else {
            $this->companyCode = $companyCode;
        }
        return $this;
    }
    /**
     * Get serviceTypeCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getServiceTypeCode()
    {
        return isset($this->serviceTypeCode) ? $this->serviceTypeCode : null;
    }
    /**
     * Set serviceTypeCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $serviceTypeCode
     * @return \StructType\GetCompanyEndpointsByServiceType
     */
    public function setServiceTypeCode($serviceTypeCode = null)
    {
        // validation for constraint: string
        if (!is_null($serviceTypeCode) && !is_string($serviceTypeCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serviceTypeCode, true), gettype($serviceTypeCode)), __LINE__);
        }
        if (is_null($serviceTypeCode) || (is_array($serviceTypeCode) && empty($serviceTypeCode))) {
            unset($this->serviceTypeCode);
        } else {
            $this->serviceTypeCode = $serviceTypeCode;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetCompanyEndpointsByServiceType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
